//this is the electronic candle by Eric Bogatin
// eric@EricBogatin.com

float pi = 3.141596;

//generating the sine wave:
int Amp_LED1_8bits = 255; // 0 to 255, 8 bit resolution
float freq_Hz = 1;  // frequency in Hz
//****************************************

//calc the difference signal
int Scale_A0 = 50; //scale factor to multiple fluctuation
int Offset_A0 = 512; //center the level

int RawSensor_10bit;  // this is the value read at the sensor. If too large, rese
int ThresholdReset_10bit = 500; //if output value varies by +/- this much, adjust_offset
int Adjusted_10bit;// this is the signal that would be the LED signal in 10 bit

int DAC_6_8bit;    //this is the processed value to drive LED

//*********************************



unsigned long timer0; //the time in millis now

void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(19200);
  pinMode(6, OUTPUT);  // is the output to the LED current booster
  //noInterrupts();  //makes for smoother analysis
  timer0 = millis(); // start the clock
  RawSensor_10bit = analogRead(A1);
}


void loop() // the loop routine runs over and over again forever:
{
  //drive_sine_wave();
  candle();
}

void candle() // modulate LED with input from A1
{
  // RawSensor_10bit) is measured in the void setup ()
  Adjusted_10bit = ((analogRead(A1) - RawSensor_10bit) * Scale_A0 + Offset_A0);
  if (abs(Adjusted_10bit - 512) > ThresholdReset_10bit) {
    RawSensor_10bit = analogRead(A1);
  }
  DAC_6_8bit = Adjusted_10bit / 4;
  analogWrite(6, DAC_6_8bit);// driving LED with pin 3;
  //Serial.println(Adjusted_10bit);
  Serial.println(DAC_6_8bit);
}


void drive_sine_wave() // modulate LED with a sine wave
{
  float time_now_ms = (millis() - timer0); // this is the time in sec from timer start
  float time_now_sec = time_now_ms / 1000.;
  int Int_LED1_8bits = Amp_LED1_8bits / 2 * (sin(2 * pi * freq_Hz * time_now_sec) + 1);
  analogWrite(6, Int_LED1_8bits);// driving LED with pin 6

  Serial.println(Int_LED1_8bits);
}


